import { Reducible, Action, Dispatch } from 'pretur.redux';
import { Query, QueryFilters, Ordering } from 'pretur.sync';
export declare class Querier<T> implements Reducible {
    readonly uniqueId: number;
    readonly count?: number;
    readonly query: Query<T>;
    constructor(query: Query<T>, count?: number, uniqueId?: number);
    reduce(action: Action<any, any>): this;
    setAttributes(dispatch: Dispatch, attributes?: (keyof T)[]): void;
    resetFilters(dispatch: Dispatch, filters?: QueryFilters<T>): void;
    setFilter(dispatch: Dispatch, field: keyof T, filter: any): void;
    clearFilter(dispatch: Dispatch, field: keyof T): void;
    setPagination(dispatch: Dispatch, skip?: number, take?: number): void;
    setOrder(dispatch: Dispatch, field: string, ordering?: Ordering, chain?: string[]): void;
    setExtra(dispatch: Dispatch, extra?: any, resetPagination?: boolean): void;
    setCount(dispatch: Dispatch, count?: number): void;
}
