import { ValidationError } from 'pretur.validation';
import { Action, Dispatch } from 'pretur.redux';
import { Clay, State } from './clay';
export declare class Record<T> implements Clay {
    readonly uniqueId: number;
    readonly original: this;
    readonly state: State;
    readonly fields: T;
    readonly error: ValidationError;
    constructor(fields?: T, error?: ValidationError, state?: State, original?: Record<T>, uniqueId?: number);
    readonly modified: boolean;
    readonly valid: boolean;
    reduce(action: Action<any, any>): this;
    clear(dispatch: Dispatch): void;
    replace(dispatch: Dispatch, by: this): void;
    setField<K extends keyof T>(dispatch: Dispatch, field: K, value: T[K]): void;
    setError(dispatch: Dispatch, error: ValidationError): void;
    setState(dispatch: Dispatch, state: State): void;
    remove(dispatch: Dispatch): void;
    unremove(dispatch: Dispatch): void;
}
